for i = 1, NUM_CHAT_WINDOWS do
   _G["ChatFrame"..i]:SetClampRectInsets(-35, 35, 35, -35);
end

local EventWatcher = CreateFrame("Frame");
local TimerAutoSell = CreateFrame("Frame");
local NameplateWatcher = CreateFrame("Frame");

function Remove(name)
	if ( not UrzTrashCan ) then
		UrzTrashCan = CreateFrame("Frame", "UrzTrashCan", UIParent);
		UrzTrashCan:Hide();
	end
	if ( name ) then
		name:SetParent(UrzTrashCan);
	end
end

function Move(name, p1, parent, p2, x, y)
	name:ClearAllPoints();
	name:SetPoint(p1, parent, p2, x, y);
end

local function EventHandler(self, event, ...)
	if ( event == "MERCHANT_SHOW" ) then
		if ( CanMerchantRepair() ) then
			local cost = GetRepairAllCost();
			if ( cost > 0 ) then
				local done = false;
				if ( IsInGuild() ) and ( CanGuildBankRepair() ) then
					if ( cost <= GetGuildBankWithdrawMoney() ) then
						if ( UrzVariables[4] ) then
							done = true;
							RepairAllItems(1);
						end
					end 
				end
				if ( UrzVariables[3] and not done ) then
					RepairAllItems();
				end
			end
		end
		if ( UrzVariables[5] ) then
			TimerAutoSell:Show();
		end
	end
	if (( UrzVariables[8] ) and ( not IsShiftKeyDown() )) then
		if ( event == "QUEST_DETAIL" ) then
			if ( not QuestGetAutoAccept() ) then
				AcceptQuest();
			else
				CloseQuest();
			end
		end
		if ( event == "QUEST_ACCEPT_CONFIRM" ) then
			ConfirmAcceptQuest();
			StaticPopup_Hide("QUEST_ACCEPT_CONFIRM");
		end
		if ( event == "QUEST_PROGRESS" ) then
			if ( IsQuestCompletable() ) then
				CompleteQuest();
			end
		end
		if ( event == "QUEST_COMPLETE" ) then
			if ( GetNumQuestChoices() <= 1 ) then
				GetQuestReward(GetNumQuestChoices());
			end
		end
	end
	if (( UrzVariables[9] ) and ( event == "LOOT_READY" )) then
		if ( GetCVar("autoLootDefault") ~= IsModifiedClick("AUTOLOOTTOGGLE") ) then
			for i = 1, GetNumLootItems() do
				LootSlot(i);
			end
		end
	end
end

local function SetMainMenu()
	for _, name in pairs({MainMenuBarPageNumber, ActionBarUpButton, ActionBarDownButton, MainMenuBarLeftEndCap, MainMenuBarRightEndCap, MainMenuXPBarTextureLeftCap, MainMenuXPBarTextureMid, MainMenuXPBarTextureRightCap, StanceBarLeft, StanceBarMiddle, StanceBarRight, SlidingActionBarTexture0, SlidingActionBarTexture1, PossessBackground1, PossessBackground2, ReputationWatchBar.StatusBar.WatchBarTexture0, ReputationWatchBar.StatusBar.WatchBarTexture1, ReputationWatchBar.StatusBar.WatchBarTexture2, ReputationWatchBar.StatusBar.WatchBarTexture3, ReputationWatchBar.StatusBar.XPBarTexture0, ReputationWatchBar.StatusBar.XPBarTexture1, ReputationWatchBar.StatusBar.XPBarTexture2, ReputationWatchBar.StatusBar.XPBarTexture3, MainMenuBarTexture0, MainMenuBarTexture1, MainMenuBarTexture2, MainMenuBarTexture3, MainMenuMaxLevelBar0, MainMenuMaxLevelBar1, MainMenuMaxLevelBar2, MainMenuMaxLevelBar3, MainMenuXPBarDiv1, MainMenuXPBarDiv2, MainMenuXPBarDiv3, MainMenuXPBarDiv4, MainMenuXPBarDiv5, MainMenuXPBarDiv6, MainMenuXPBarDiv7, MainMenuXPBarDiv8, MainMenuXPBarDiv9, MainMenuXPBarDiv10, MainMenuXPBarDiv11, MainMenuXPBarDiv12, MainMenuXPBarDiv13, MainMenuXPBarDiv14, MainMenuXPBarDiv15, MainMenuXPBarDiv16, MainMenuXPBarDiv17, MainMenuXPBarDiv18, MainMenuXPBarDiv19}) do
		Remove(name);
	end
	for _, name in pairs({StanceBarFrame, PossessBarFrame, PetActionBarFrame, MultiBarLeft, MultiBarRight, MultiBarBottomLeft, MultiBarBottomRight, MainMenuBar, MainMenuBarMaxLevelBar}) do
		name:SetFrameStrata("MEDIUM");
		name:EnableMouse(false);
	end
	for _, text in pairs({"ActionButton", "MultiBarBottomLeftButton", "MultiBarBottomRightButton", "MultiBarLeftButton", "MultiBarRightButton", "StanceButton", "PossessButton", "PetActionButton"}) do
		for i = 1, 12 do
			local name = _G[text..i];
			if ( name ) then
				name:SetScale(1);
				name:SetSize(36, 36);
				name:GetNormalTexture():SetPoint("TOPLEFT", name, "TOPLEFT", -12, 12);
				name:GetNormalTexture():SetPoint("BOTTOMRIGHT", name, "BOTTOMRIGHT", 13, -13);
				Remove(_G[text..i.."FloatingBG"]);
				Remove(_G[text..i.."Name"]);
			end
		end
	end
	MainMenuBarVehicleLeaveButton:SetSize(36, 36);
	for _, name in pairs({MainMenuBarVehicleLeaveButton, StanceBarFrame, PossessBarFrame, PetActionBarFrame}) do
		name:SetScale(0.7);
	end
	MainMenuBar:SetWidth(512);
	Move(MultiBarBottomLeftButton1, "BOTTOMLEFT", ActionButton1, "TOPLEFT", 0, 6);
	Move(MultiBarBottomRightButton1, "BOTTOMLEFT", MultiBarBottomLeftButton1, "TOPLEFT", 0, 6);
	Move(StanceButton1, "BOTTOMLEFT", MultiBarBottomRightButton1, "TOPLEFT", 0, 6);
	Move(PossessButton1, "BOTTOMLEFT", MultiBarBottomRightButton1, "TOPLEFT", 0, 6);
	Move(PetActionButton10, "BOTTOMRIGHT", MultiBarBottomRightButton12, "TOPRIGHT", 0, 6);
	Move(PossessButton2, "LEFT", PossessButton1, "RIGHT", 6, 0);
	for i = 2, 10 do
		Move(_G["StanceButton"..i], "LEFT", _G["StanceButton"..i-1], "RIGHT", 6, 0);
		Move(_G["PetActionButton"..11-i], "RIGHT", _G["PetActionButton"..12-i], "LEFT", -6, 0);
	end
	local function setup()
		if (( GetNumShapeshiftForms() < 1 ) and not IsPossessBarVisible() ) then
			Move(MainMenuBarVehicleLeaveButton, "BOTTOMLEFT", MultiBarBottomRightButton1, "TOPLEFT", 0, 6);
		end
	end
	setup();
	hooksecurefunc("MainMenuBarVehicleLeaveButton_Update", setup);
	local function setup()
		if ( MainMenuBar:IsShown() ) then
			Move(CharacterMicroButton, "BOTTOMLEFT", UIParent, "BOTTOMRIGHT", -285, 1);
			Move(GuildMicroButton, "BOTTOMLEFT", QuestLogMicroButton, "BOTTOMRIGHT", -3, 0);
		end
	end
	setup();
	hooksecurefunc("MoveMicroButtons", setup);
	local function setup()
		MainMenuExpBar:SetSize(283, 13);
		ReputationWatchBar:SetSize(283, 13);
		ReputationWatchBar.StatusBar:SetSize(ReputationWatchBar:GetSize());
		Move(ReputationWatchBar.OverlayFrame.Text, "CENTER", ReputationWatchBar.OverlayFrame, "CENTER", 0, 1);
		ReputationWatchBar.OverlayFrame:SetFrameStrata("MEDIUM");
		local y = 0;
		if ( not UrzVariables[12] ) then
			y = y+40;
		end
		Move(MainMenuExpBar, "BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -1, y);
		if ( MainMenuExpBar:IsShown() ) then
			y = y+16;
		end
		Move(ReputationWatchBar, "BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -1, y);
		if ( ReputationWatchBar:IsShown() ) then
			y = y+16;
		end
		Move(MainMenuBarBackpackButton, "BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -1, y);
	end
	setup();
	hooksecurefunc("MainMenuBar_UpdateExperienceBars", setup);
end

local function SetMinimap()
	for _, name in pairs({TimeManagerClockButton:GetRegions(), MiniMapWorldMapButton, MinimapZoomIn, MinimapZoomOut, MiniMapTracking}) do
		Remove(name);
	end
	MinimapZoneTextButton:SetScript("OnClick", ToggleWorldMap);
	MinimapZoneText:SetWidth(120);
	Move(MinimapZoneTextButton, "LEFT", MinimapCluster, "CENTER", -70, 83);
	Move(MinimapZoneText, "LEFT", MinimapCluster, "CENTER", -70, 83);
	Move(TimeManagerClockButton, "RIGHT", MinimapCluster, "CENTER", 97, 81);
	Move(TimeManagerClockTicker, "RIGHT", MinimapCluster, "CENTER", 86, 83);
	MinimapZoneText:SetFont("Fonts\\FRIZQT__.TTF", 11);
	TimeManagerClockTicker:SetFont("Fonts\\FRIZQT__.TTF", 11);
	Minimap:EnableMouseWheel(true);
	Minimap:SetScript("OnMouseWheel", function(self, delta)
		local zoom = Minimap:GetZoom();
		if ( delta > 0 and zoom < 5 ) then
			Minimap:SetZoom(zoom+1);
		elseif ( delta < 0 and zoom > 0 ) then
			Minimap:SetZoom(zoom-1);
		end
	end);
	Minimap:SetScript("OnMouseUp", function(self, button)
		if ( button == "LeftButton" ) then
			Minimap_OnClick(self);
		elseif ( button == "RightButton" ) then
			PlaySound("igMainMenuOptionCheckBoxOn");
			ToggleDropDownMenu(1, nil, MiniMapTrackingDropDown, "Minimap", -150, 130);
		end
	end);
	GarrisonLandingPageMinimapButton:SetScale(0.7)
	GarrisonLandingPageMinimapButton:ClearAllPoints();
	GarrisonLandingPageMinimapButton:SetPoint("TOPLEFT", MinimapBackdrop, "TOPLEFT", 57, -169);
end

local function HideBags()
	for _, name in pairs({MainMenuBarBackpackButton, CharacterBag0Slot, CharacterBag1Slot, CharacterBag2Slot, CharacterBag3Slot}) do
		Remove(name);
	end
	for i = 1, #MICRO_BUTTONS do
		Remove(_G[MICRO_BUTTONS[i]]);
	end
end

local function SetAutoSell()
	local timer = 1;
	local start = false;
	local items = false;
	TimerAutoSell:Hide();
	TimerAutoSell:SetScript("OnUpdate", function(self, elapsed)
		if (( not start ) and ( timer >= 1 )) then
			start = true;
			timer = 0;
			items = false;
			for bag = 0, 4 do
				for slot = 0, GetContainerNumSlots(bag) do
					local link = GetContainerItemLink(bag, slot);
					if (( link ) and ( (select(3, GetItemInfo(link)) == 0) )) then
						UseContainerItem(bag, slot);
						items = true;
					end
				end
			end
			if ( not items ) then
				timer = 1;
				start = nil;
				TimerAutoSell:Hide();
			end
			start = nil;
		else
			timer = timer+elapsed;
		end
	end);
end

local function SetRightClick()
	UrzRightClickUpdateDelay = 0;
	WorldFrame:HookScript("OnMouseUp", function(self, button)
		if ( UrzVariables[7] ) then
			if ( UnitAffectingCombat("player") and ( button == "RightButton" ) and ( UrzRightClickUpdateDelay < GetTime() )) then
				UrzRightClickUpdateDelay = GetTime()+0.3;
				MouselookStop();
			end
		end
	end);
end

local function SetURLCopy()
	for _, name in pairs({"CHAT_MSG_SAY", "CHAT_MSG_WHISPER", "CHAT_MSG_YELL", "CHAT_MSG_GUILD", "CHAT_MSG_OFFICER", "GUILD_MOTD", "CHAT_MSG_BN_WHISPER", "CHAT_MSG_BN_CONVERSATION", "CHAT_MSG_BN_INLINE_TOAST_BROADCAST", "CHAT_MSG_PARTY", "CHAT_MSG_PARTY_LEADER", "CHAT_MSG_RAID", "CHAT_MSG_RAID_LEADER", "CHAT_MSG_INSTANCE_CHAT", "CHAT_MSG_INSTANCE_CHAT_LEADER", "CHAT_MSG_CHANNEL"}) do
		ChatFrame_AddMessageEventFilter(name, function(_, _, msg, ...)
			local newMsg, found = gsub(msg, "[^ \"£%^`¨{}%[%]\\|<>]+[^ '%-=%./,\"£%^`¨{}%[%]\\|<>%d]%.[^ '%-=%./,\"£%^`¨{}%[%]\\|<>%d][^ \"£%^`¨{}%[%]\\|<>]+", "|cff9999ff|Hurzurl~%1|h[%1]|h|r");
			if ( found > 0 ) then
				return false, newMsg, ...;
			end
			newMsg, found = gsub(msg, "^%x+[%.:]%x+[%.:]%x+[%.:]%x+[^ \"£%^`¨{}%[%]\\|<>]*", "|cff9999ff|Hurzurl~%1|h[%1]|h|r");
			if ( found > 0 ) then
				return false, newMsg, ...;
			end
			newMsg, found = gsub(msg, " %x+[%.:]%x+[%.:]%x+[%.:]%x+[^ \"£%^`¨{}%[%]\\|<>]*", "|cff9999ff|Hurzurl~%1|h[%1]|h|r");
			if ( found > 0 ) then
				return false, newMsg, ...;
				end
		end);
	end
	local old = ItemRefTooltip.SetHyperlink;
	function ItemRefTooltip:SetHyperlink(data, ...)
		local isURL, link = strsplit("~", data);
		if (( isURL ) and ( isURL == "urzurl" )) then
			local activeWindow = ChatEdit_GetActiveWindow();
			if ( activeWindow ) then
				activeWindow:SetText(link);
				ChatEdit_FocusActiveWindow();
				activeWindow:HighlightText();
			else
				activeWindow = ChatEdit_GetLastActiveWindow();
				activeWindow:Show();
				activeWindow:SetText(link);
				activeWindow:SetFocus();
				activeWindow:HighlightText();
			end
		else
			old(self, data, ...);
		end
	end
end

local function SetChatframes()
	for i = 1, NUM_CHAT_WINDOWS do
		for _, text in pairs({"ButtonFrameMinimizeButton", "ButtonFrameBackground", "ButtonFrameTopLeftTexture", "ButtonFrameBottomLeftTexture", "ButtonFrameTopRightTexture", "ButtonFrameBottomRightTexture", "ButtonFrameLeftTexture", "ButtonFrameRightTexture", "ButtonFrameBottomTexture", "ButtonFrameTopTexture"}) do
			Remove(_G["ChatFrame"..i..text]);
		end
		_G["ChatFrame"..i.."Tab"]:SetScript("OnDoubleClick", nil);
		if ( i ~= 1 ) then
			_G["ChatFrame"..i.."EditBox"]:SetAllPoints(ChatFrame1EditBox);
		end
	end
	FCFManager_RegisterDedicatedFrame(ChatFrame2, "PET_BATTLE_COMBAT_LOG");
	for name in pairs(ChatTypeGroup) do
		SetChatColorNameByClass(name, true);
	end
	for i = 1, MAX_WOW_CHAT_CHANNELS do
		local name = "CHANNEL"..i;
		if ( name ) then
			SetChatColorNameByClass(name, true);
		end
	end
	Move(FriendsMicroButton, "BOTTOM", ChatFrameMenuButton, "TOP", 0, 3);
	ChatFrameMenuButton:SetScript("OnClick", function(self, button, down)
		PlaySound("igChatEmoteButton");
		if ( not ChatMenu:IsShown() ) then
			ChatMenu:Show();
		else
			ChatMenu:Hide();
		end
	end);
	local function setup(editBox)
		editBox:SetFrameStrata("BACKGROUND");
	end
	setup(ChatFrame1EditBox);
	hooksecurefunc("ChatEdit_DeactivateChat", setup);
	hooksecurefunc("ChatEdit_SetLastActiveWindow", setup);
	hooksecurefunc("FCFDock_RemoveChatFrame", setup);
end

local function SetUnitframes()
	PlayerFrame:UnregisterEvent("UNIT_COMBAT");
	PetFrame:UnregisterEvent("UNIT_COMBAT");
	for _, name in pairs({PlayerStatusTexture, PlayerAttackBackground, PlayerFrameFlash, PlayerStatusGlow, PlayerAttackGlow, PlayerRestGlow, PlayerHitIndicator, PetFrameFlash, PetAttackModeTexture, PetHitIndicator, TargetFrameFlash, FocusFrameFlash}) do
		Remove(name);
	end
	for _, name in pairs({PlayerFrameHealthBar, PlayerFrameManaBar, PlayerPVPIconHitArea, PetFrameHealthBar, PetFrameManaBar, TargetFrameHealthBar, TargetFrameManaBar, FocusFrameHealthBar, FocusFrameManaBar}) do
	   name:EnableMouse(false);
	end
	hooksecurefunc("PlayerFrame_UpdateStatus", function()
		if (( not UnitHasVehiclePlayerFrameUI("player") ) and ( UnitAffectingCombat("player") )) then
			PlayerAttackIcon:Show();
			PlayerRestIcon:Hide();
		end
		if (( PlayerAttackIcon:IsShown() ) or ( PlayerRestIcon:IsShown() )) then
			PlayerLevelText:Hide();
		else
			PlayerLevelText:Show();
		end
	end);
	hooksecurefunc("TextStatusBar_UpdateTextString", function(textStatusBar)
			if (( textStatusBar == PlayerFrameHealthBar ) or ( textStatusBar == TargetFrameHealthBar )) then
				local current = textStatusBar:GetValue();
				local _, max = textStatusBar:GetMinMaxValues();
				if (( current > 0) and ( max > 0 )) then
					textStatusBar.TextString:SetFormattedText("%i%%   %s", ceil(current/max*100), AbbreviateLargeNumbers(current));
				end
			end
	end);
	TextStatusBar_UpdateTextString(PlayerFrameHealthBar);
	TextStatusBar_UpdateTextString(TargetFrameHealthBar);
end

local function SetMisc()
	--CastBar
	CastingBarFrame:SetFrameStrata("FULLSCREEN_DIALOG");
	
	--RaidFrames
	CompactUnitFrameProfilesGeneralOptionsFrameHeightSlider:SetMinMaxValues(16, 72);
	
	--AreaObjectives
	hooksecurefunc("WorldStateAlwaysUpFrame_Update", function()
			local numUI = GetNumWorldStateUI();
			local name;
			for i = 1, numUI do
				name = _G["AlwaysUpFrame"..i];
				if ( name ) then
					name:EnableMouse(false);
				end
			end
	end);
	
	--PetJournal
	C_PetJournal.SetPetSortParameter(LE_SORT_BY_RARITY);
end

local function SetOptionsframe()
	CreateFrame("Frame", "UrzVariablesInterface");
	UrzVariablesInterface.name = "UrzUI";
	InterfaceOptions_AddCategory(UrzVariablesInterface);
	SlashCmdList["UrzSlash"] = function(UrzVariables)
		InterfaceOptionsFrame:Show();
		InterfaceOptionsFrame_OpenToCategory("UrzUI");
	end;
	SLASH_UrzSlash1 = "/urz";
	UrzSettings = {
		[2] = {x = 24, y = 55+35*1, Text = "Hide error messages"},
		[11] = {x = 24, y = 55+35*2, Text = "Hide floating combat text"},
		[3] = {x = 24, y = 55+35*3, Text = "Auto-repair"},
		[4] = {x = 160, y = 55+35*3, Text = "Use Guild Repair"},
		[5] = {x = 24, y = 55+35*4, Text = "Auto-sell poor quality items"},
		[8] = {x = 24, y = 55+35*5, Text = "Auto-turn-in and accept quests"},
		[9] = {x = 24, y = 65+35*6, Text = "Faster auto-loot"},
		[7] = {x = 24, y = 65+35*7, Text = "Require right-double-click to loot, attack and interact with objects in combat"},
		[1] = {x = 24, y = 125+35*8, Text = "Nameplates"},
		[10] = {x = 24, y = 125+35*9, Text = "Minimap"},
		[12] = {x = 24, y = 125+35*10, Text = "Hide bags and micro buttons"},
	};
	local box = {};
	for i = 1, #UrzSettings do
		if ( UrzSettings[i] ) then
			box[i] = CreateFrame("CheckButton", "box"..i, UrzVariablesInterface, "InterfaceOptionsCheckButtonTemplate");
			Move(box[i], "TOPLEFT", UrzVariablesInterface, "TOPLEFT", UrzSettings[i]["x"], -UrzSettings[i]["y"]);
			box[i]:SetChecked(UrzVariables[i]);
			_G[box[i]:GetName().."Text"]:SetText(UrzSettings[i]["Text"]);
			box[i]:SetScript("OnClick", function(self, button, down)
				UrzVariables[i] = self:GetChecked();
			end);
			UrzVariablesInterface:SetScript("OnShow", function(self)
				for i = 1, #UrzSettings do
					if ( box[i] ) then
						box[i]:SetChecked(UrzVariables[i]);
					end
				end
			end);
		end
	end
	box[2]:HookScript("OnClick", function(self, button, down)
		if ( UrzVariables[2] ) then
			UIErrorsFrame:UnregisterEvent("UI_ERROR_MESSAGE");
		else
			UIErrorsFrame:RegisterEvent("UI_ERROR_MESSAGE");
		end
	end);
	box[11]:HookScript("OnClick", function(self, button, down)
		if ( UrzVariables[11] ) then
			ConsoleExec("floatingCombatTextCombatHealing 0");
			ConsoleExec("floatingCombatTextCombatDamage 0");
		else
			ConsoleExec("floatingCombatTextCombatHealing 1");
			ConsoleExec("floatingCombatTextCombatDamage 1");
		end
	end);
	local text1 = UrzVariablesInterface:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge");
	local text2 = UrzVariablesInterface:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall");
	local text3 = UrzVariablesInterface:CreateFontString(nil, "ARTWORK", "GameFontNormal");
	local text4 = UrzVariablesInterface:CreateFontString(nil, "ARTWORK", "GameFontNormal");
	local text5 = UrzVariablesInterface:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall");
	local text6 = UrzVariablesInterface:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall");
	local text7 = UrzVariablesInterface:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall");
	text1:SetText("UrzUI");
	text2:SetText("Dedicated to my partner Madelene.");
	text3:SetText("Optional functions");
	text4:SetText("Interface tweaks");
	text5:SetText("Requires a reload for changes to take effect.");
	text6:SetText("This means that you can no longer accidentally target or attack a mob when you move the camera.");
	text7:SetText("Hold down shift to disable temporarily.");
	text6:SetJustifyH("LEFT");
	text1:SetPoint("TOPLEFT", 16, -16);
	text2:SetPoint("TOPLEFT", text1, "BOTTOMLEFT", 0, -8);
	text3:SetPoint("BOTTOMLEFT", box[2], "TOPLEFT", 0, 8);
	text4:SetPoint("BOTTOMLEFT", text5, "TOPLEFT", 0, 8);
	text5:SetPoint("BOTTOMLEFT", box[1], "TOPLEFT", 0, 8);
	text6:SetPoint("TOPLEFT", box[7], "BOTTOMLEFT", 40, 2);
	text7:SetPoint("TOPLEFT", box[8], "BOTTOMLEFT", 40, 2);
	local b = CreateFrame("Button", nil, UrzVariablesInterface, "UIPanelButtonTemplate");
	b:SetSize(100, 22);
	b:SetText("Reload UI");
	b:SetPoint("BOTTOMRIGHT", -16, 16);
	b:SetScript("OnClick", function(self, button, down)
		ReloadUI();
	end)
end

local function LoadAddon()
	if ( UrzVariables[10] ) then
		SetMinimap();
	end
	if ( UrzVariables[12] ) then
		HideBags();
	end
	SetUnitframes();
	SetChatframes();
	SetMainMenu();
	SetAutoSell();
	SetRightClick();
	SetURLCopy();
	SetMisc();
	SetOptionsframe();
	if ( UrzVariables[2] ) then
		UIErrorsFrame:UnregisterEvent("UI_ERROR_MESSAGE");
	end
	EventWatcher:RegisterEvent("MERCHANT_SHOW");
	EventWatcher:RegisterEvent("QUEST_DETAIL");
	EventWatcher:RegisterEvent("QUEST_ACCEPT_CONFIRM");
	EventWatcher:RegisterEvent("QUEST_PROGRESS");
	EventWatcher:RegisterEvent("QUEST_COMPLETE");
	EventWatcher:RegisterEvent("LOOT_READY");
	EventWatcher:SetScript("OnEvent", EventHandler);
	collectgarbage();
end

local virgin = true;
EventWatcher:SetScript("OnEvent", function(self, event, ...)
	if ( virgin ) then
		virgin = nil;
		if (( not UrzVariables ) or (( UrzVariables ) and ( type(UrzVariables) ~= "table" ))) then
			UrzVariables = {[1] = 1, [2] = 1, [3] = 1, [5] = 1, [8] = 1, [9] = 1, [10] = 1};
		end
		if ( UrzVariables[1] ) then
			NameplateWatcher:SetScript("OnEvent", function(self, event, ...)
					local plate = ...;
					plate.UnitFrame.name:SetFont("Fonts\\ARIALN.TTF", 12);
					plate.UnitFrame.name:SetShadowOffset(1, -1);
			end);
			NameplateWatcher:RegisterEvent("NAME_PLATE_CREATED");
			for _, t in pairs({"Friendly", "Enemy"}) do
				for _, d in pairs({"displayNameWhenSelected", "displayNameByPlayerNameRules"}) do
					_G["DefaultCompactNamePlate"..t.."FrameOptions"][d] = false;
				end
			end
			SetCVar("nameplateMinAlpha", 1); --0.5
			SetCVar("nameplateMinScale", 1); --0.8
			SetCVar("nameplateOtherTopInset", -1);  --0.08
			SetCVar("nameplateOtherBottomInset", -1);  --0.1
			local function setup(frame)
				local isTanking = UnitDetailedThreatSituation("player", frame.displayedUnit);
				if ( not isTanking ) then
					frame.name:SetVertexColor(1, 1, 1, 1);
				else
					frame.name:SetVertexColor(1, 0, 0, 1);
				end
			end
			hooksecurefunc("CompactUnitFrame_UpdateName", setup);
			hooksecurefunc("CompactUnitFrame_UpdateAggroFlash", setup);
		end
	end
	if ( not UnitAffectingCombat("player") ) then
		EventWatcher:UnregisterAllEvents();
		LoadAddon();
	end
end);
EventWatcher:RegisterEvent("PLAYER_ENTERING_WORLD");
EventWatcher:RegisterEvent("PLAYER_REGEN_ENABLED");
